﻿Imports System.Data.SqlClient

Public Class RH_Datos_Empleado
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Not IsPostBack Then
            LoadCombos()
        End If

    End Sub

    Public Sub guardaEmpleado()

        Dim empleado As New RH_Empleados_Datos_Manager
        empleado.Add(NoEmp.Value, Nombre.Value, ApePaterno.Value, ApeMaterno.Value, Edad.Value, CP.Value, Telefono.Value, Celular.Value, Dir.Value, True, ddl_EdoCivil.SelectedValue, ddl_Estado.SelectedValue, ddl_Municipio.SelectedValue, ddl_Colonia.SelectedValue)

        Dim contacto1 As New RH_Empleado_Contactos_Manager
        contacto1.Add(c1_nombre.Value, c1_ApePat.Value, c1_ApeMat.Value, c1_telefono.Value, c1_celular.Value, NoEmp.Value, True)

        Dim contacto2 As New RH_Empleado_Contactos_Manager
        contacto2.Add(c2_nombre.Value, c2_ApePat.Value, c2_ApeMat.Value, c2_telefono.Value, c2_celular.Value, NoEmp.Value, True)

    End Sub

    Protected Sub InsertButton_Click(sender As Object, e As EventArgs) Handles InsertButton.Click

        If valNoEmp(NoEmp.Value) = False Then
            If Page.IsValid = True Then
                guardaEmpleado()
                jsAlert("Se ha guardado la información de manera correcta!")
                Response.Redirect("http://www.outhelping.com.mx")
            End If
        Else
            jsAlert("El número de empleado ya ha sido registrado en la Base de Datos!")
            Response.Redirect("RH_Datos_Empleado.aspx")
        End If

    End Sub

    Protected Sub CancelButton_Click(sender As Object, e As EventArgs) Handles CancelButton.Click
        Response.Redirect("http://www.outhelping.com.mx")
    End Sub

    Public Sub jsAlert(ByVal Message As String)
        Response.Write("<script language='javascript'>alert('" + Message + "');</script>")
    End Sub

    Public Sub LoadCombos()

        ddl_EdoCivil.Items.Clear()
        ddl_EdoCivil.DataSource = getEstadoCivil()
        ddl_EdoCivil.DataValueField = "Id_EdoCivil"
        ddl_EdoCivil.DataTextField = "EdoCivil_Descr"
        ddl_EdoCivil.DataBind()
        ddl_EdoCivil.Items.Insert(0, "SELECCIONE...")
        ddl_EdoCivil.SelectedIndex = 0

        ddl_Estado.Items.Clear()
        ddl_Estado.DataSource = getEstados()
        ddl_Estado.DataValueField = "Id_Estado"
        ddl_Estado.DataTextField = "Descr_Estado"
        ddl_Estado.DataBind()
        ddl_Estado.Items.Insert(0, "SELECCIONE...")
        ddl_Estado.SelectedIndex = 0

        ddl_Municipio.Items.Clear()
        ddl_Municipio.Items.Insert(0, "SELECCIONE")
        ddl_Municipio.SelectedIndex = 0
        ddl_Municipio.Enabled = False

        ddl_Colonia.Items.Clear()
        ddl_Colonia.Items.Insert(0, "SELECCIONE")
        ddl_Colonia.SelectedIndex = 0
        ddl_Colonia.Enabled = False

    End Sub

    Public Function valNoEmp(NoEmp As String) As Boolean

        Dim locCont As Integer
        Dim db As New OH_TI_Entities

        Dim Empleado = db.RH_Empleados_Datos.Where(Function(v) v.Emp_NoEmp = NoEmp)
        locCont = Empleado.Count()

        If locCont = 0 Then
            valNoEmp = False
        Else
            valNoEmp = True
        End If

        Return valNoEmp

    End Function

    Public Function getEstadoCivil() As DataSet
        Dim strConString As String = ConfigurationManager.ConnectionStrings("OutHell_TI").ConnectionString
        Dim con As SqlConnection = New SqlConnection(strConString)
        Dim strSQL As String
        strSQL = "SELECT * FROM CAT_RH_EdoCivil WHERE IsValid = '1' "

        Dim da As New SqlDataAdapter(strSQL, con)
        Dim ds = New DataSet
        da.Fill(ds)
        Return ds

    End Function

    Public Function getEstados() As DataSet
        Dim strConString As String = ConfigurationManager.ConnectionStrings("OutHell_TI").ConnectionString
        Dim con As SqlConnection = New SqlConnection(strConString)
        Dim strSQL As String
        strSQL = "SELECT * FROM CAT_EstadosMex"

        Dim da As New SqlDataAdapter(strSQL, con)
        Dim ds = New DataSet
        da.Fill(ds)
        Return ds

    End Function

    Public Function getMunicipios() As DataSet
        Dim strConString As String = ConfigurationManager.ConnectionStrings("OutHell_TI").ConnectionString
        Dim con As SqlConnection = New SqlConnection(strConString)
        Dim strSQL As String
        strSQL = "SELECT * FROM CAT_MunicipiosMex " & _
            "WHERE Id_Estado = '" & ddl_Estado.SelectedValue.ToString & "' " & _
            "ORDER BY Descr_Municipio"

        Dim da As New SqlDataAdapter(strSQL, con)
        Dim ds = New DataSet
        da.Fill(ds)
        Return ds

    End Function

    Public Function getLocalidades() As DataSet
        Dim strConString As String = ConfigurationManager.ConnectionStrings("OutHell_TI").ConnectionString
        Dim con As SqlConnection = New SqlConnection(strConString)
        Dim strSQL As String
        strSQL = "SELECT * FROM CAT_LocalidadesMex " & _
            "WHERE Id_Municipio = '" & ddl_Municipio.SelectedValue.ToString & "' " & _
            "ORDER BY Descr_Localidad"

        Dim da As New SqlDataAdapter(strSQL, con)
        Dim ds = New DataSet
        da.Fill(ds)
        Return ds

    End Function

    Private Sub ddl_Estado_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ddl_Estado.SelectedIndexChanged

        Dim IntIndex As Integer

        If ddl_Estado.SelectedIndex <> 0 Then

            IntIndex = 0

            ddl_Municipio.Items.Clear()
            ddl_Municipio.DataSource = getMunicipios()
            ddl_Municipio.DataValueField = "Id_Municipio"
            ddl_Municipio.DataTextField = "Descr_Municipio"
            ddl_Municipio.DataBind()
            ddl_Municipio.Items.Insert(0, "SELECCIONE...")
            ddl_Municipio.SelectedIndex = 0
            ddl_Municipio.Enabled = True

            ddl_Colonia.Items.Clear()
            ddl_Colonia.Items.Insert(0, "SELECCIONE")
            ddl_Colonia.SelectedIndex = 0
            ddl_Colonia.Enabled = False

        Else

            ddl_Municipio.Items.Clear()
            ddl_Municipio.Items.Insert(0, "SELECCIONE")
            ddl_Municipio.SelectedIndex = 0
            ddl_Municipio.Enabled = False

            ddl_Colonia.Items.Clear()
            ddl_Colonia.Items.Insert(0, "SELECCIONE")
            ddl_Colonia.SelectedIndex = 0
            ddl_Colonia.Enabled = False

        End If

    End Sub

    Private Sub ddl_Municipio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ddl_Municipio.SelectedIndexChanged

        Dim IntIndex As Integer

        If ddl_Municipio.SelectedIndex <> 0 Then

            IntIndex = 0

            ddl_Colonia.Items.Clear()
            ddl_Colonia.DataSource = getLocalidades()
            ddl_Colonia.DataValueField = "Id_Localidad"
            ddl_Colonia.DataTextField = "Descr_Localidad"
            ddl_Colonia.DataBind()
            ddl_Colonia.Items.Insert(0, "SELECCIONE...")
            ddl_Colonia.SelectedIndex = 0
            ddl_Colonia.Enabled = True

        Else

            ddl_Colonia.Items.Clear()
            ddl_Colonia.Items.Insert(0, "SELECCIONE")
            ddl_Colonia.SelectedIndex = 0
            ddl_Colonia.Enabled = False

        End If

    End Sub

End Class